	/*
		封装函数:
			1 是否被多次使用
			2 会出现哪些不确定的值，把不确定的传进去，确定就不需要传
				method  		请求的方式
				url     		请求地址
				data    		传递的参数
				aysn			同步、异步
				contentType     请求头信息不一样
				success			成功的数据

	*/ 
	/*
		用法
		$ajax({
			method:"请求的方式",
			url:"接口地址",
			data:{
				a:"参数1",
				b:"参数2"
			},
			aysn:true,
			contentType:"application/x-www-form-urlencoded",
			success:function(row){
				var obj=JSON.parse(row)
				console.log(obj,"请求成功的数据")
			}
		})
	*/ 
	// 以对象的形式接收传进来的参数，那么形参必须要与对象的属性一样
	function $ajax({method,url,data,aysn,contentType,success}) {
		// console.log(method)
		// console.log(url)
		// console.log(data)
		// console.log(aysn)
		// console.log(contentType)
		// console.log(success)
		// 1 创建ajax对象
		var xhr=new XMLHttpRequest()
		// {
		// 	a:"参数1",
		// 	b:"参数2"
		// }
		// 将对象转成a=参数1&b=参数2
		// 将对象处理成拼接字符串
		data=querystring(data)

		// 如果是get并且data是有数据那么拼接？和参数：http://wwww.baidu.com?a=参数1&b=参数2
		// 如果是get不需要传参数：http://wwww.baidu.com
		// 否则就是post：http://wwww.baidu.com
		if(method=="get"&&data.length){
			url+="?"+data
		}
		// url 在get中url拼接参数  1、接口地址？参数1=参数值1&参数n=参数n的值  2、接口地址
		// url 在post中url 直接就是接口地址

		// 2 创建http请求,get请求拼接参数实在open中，post请求拼接参数实在send中
		xhr.open(method,url,aysn)

		// 如果有请求头就设置请求头
		if(contentType){
			// 设置请求头
			xhr.setRequestHeader("Content-type",contentType)
		}
		
		// 3 发送请求 post拼接参数
		// telnumber=18746526341&password=123456
		// 如果是get就直接发送
		if(method=="get"){
			xhr.send()
		}else{
			// 否则post拼接参数
			xhr.send(data)
		}
		
		// 4 设置监听函数
		xhr.onreadystatechange=function(){
			if(xhr.readyState===4&&xhr.status===200){
				// 调用传进来的对象中的函数，回调函数
				success(xhr.responseText)
			}
		}
	}
	function querystring(obj) {
		// console.log(obj)
		var str=""
		for(var i in obj){
			// console.log(i) // 属性
			// console.log(obj[i]) // 属性值
			// 属性=属性值&属性=属性值
			str+=i+"="+obj[i]+"&"
		}
		// tel=12346&pa=789&
		// 截取删除最后一项
		return str.substring(0,str.length-1)
	}